/***************************************************************************
                          kappldialogitem.h  -  description                              
                             -------------------                                         
    begin                : Thu Aug 26 1999                                           
    copyright            : (C) 1999 by Geri House                         
    email                : ge_ha@yahoo.com                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef KAPPLDIALOGITEM_H
#define KAPPLDIALOGITEM_H

#include <qlistview.h>
#include <qfileinfo.h>

/**
  * This class provides the dialog items for the KApplDialog. It is derived from the QListViewItem
  * and overloads some functions and add some own stuff. Every KApplDialogItem has its own FileInfo.
  * @author Geri House
  * @see KApplDialog
  */

class KApplDialogItem : public QListViewItem  {
public: 
  	/** Constructor */
	KApplDialogItem( QFileInfo f, QListViewItem * parent, const char *, const char * );
  	/** Destructor */
	~KApplDialogItem();
  	/** Returns the QFileInfo of the Item */
	QFileInfo getFileInfo() { return finfo;}
private:
	QFileInfo finfo;	
};

#endif







