/***************************************************************************
    kuninstalleroption.h  -  Header file of class KUninstallerOption
    ------------------------------------------------------------------------
    begin                : Mon Mar 22 1999                                           
    copyright            : (C) 1999 by Geri House                         
    email                : ge_ha@yahoo.com                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef KUNINSTALLEROPTION_H
#define KUNINSTALLEROPTION_H

#include <qdialog.h>
#include <qchkbox.h>
#include <qpushbt.h>
#include <qlined.h>
#include <qradiobt.h>
#include <qspinbox.h>
#include <qlabel.h>

/**
  * This class provides the Option Dialog. With it you can configure some settings.
  * It will opened through the configuration button in the toolbar or from the
  * menue.
  * @author Geri House
  */

class KUninstallerOption : public QDialog  {

Q_OBJECT

public: 
  	/** Constructor */
	KUninstallerOption(QWidget * parent=0, const char * name=0, bool modal=FALSE);
  	/** Destructor */
	~KUninstallerOption();
private slots:
	void closeWithSaving();	
	void updateBtnGroup();
	void updateAddSearch();
	void selectDir();
	void selectSearchDir();
private:
 	QCheckBox* backupCheckBtn;
 	QCheckBox *addSearchBtn;
	QPushButton* dirBtn;
	QPushButton *dirSearchBtn;
	QRadioButton* defaultRadioBtn;
	QRadioButton* ownRadioBtn;
	QLineEdit* pathLineEdit;
	QLineEdit *pathSearchEdit;
	QSpinBox *numberBackups;
	QLabel *label2;
};

#endif





















